console.log( "mapL.js loading.." );

mapL = new Object();
mapL.eves = map_eves;

addEventListener( "load", function() {
/*
	マップのデータ初期化と、
	画像のプリロード。
*/
	dts = null;
	this.anms = new Array();

	this.scrollDot = 4;
	this.scrollTime = 16 * timerMS / this.scrollDot;
	this.scrolling = null;
	this.matrixMaxCols = 17;
	this.matrixMaxRows = 15;
	this.playerCol =  ( this.matrixMaxCols - 1 ) / 2;
	this.playerRow =  ( this.matrixMaxRows - 1 ) / 2;
	this.charTick = 0;
		var anm = new Anm( 2, 900, this, "charTick", null, null );
			anm.loopFLG = true;
			console.log( anm.addLen );
		this.anms.push( anm );
		
	
	this.screenOffsetX = 0;
	this.screenOffsetY = 0;
	
	this.movedFlg = false;

	this.table = {
		"0_0_255" 		:	0,	//水
		"255_255_255"	:	1,	//雪
		"11_128_11"		:	2,	//木
		"0_255_0"		:	3,	//草
		"128_128_128"	:	4,	//岩山
		"255_0_0"		:	5,	//町
		"255_255_0"		:	6,	//砂
	};
	this.table2 = new Array();
	for( var id in this.table ) {
		this.table2[ this.table[ id ] ] = id;
	}
	this.table3 = [
		"_mapchips/mizu.png",
		"_mapchips/yuki.png",
		"_mapchips/ki.png",
		"_mapchips/kusa.png",
		"_mapchips/iwayama.png",
		"_mapchips/machi.png",
		"_mapchips/suna.png",
	];
	this.table4 = [
		"_mapchips/chr1.png",
	];
	
	this.mapchips = new Array();
	this.charImages = new Array();
	this.images = new Array();
	this.imageNames = [
		"land.png",
	];
	this.maps = new Object();
	
	this.preloaded = false;
	this.preload1();
}.bind( mapL ), false );

mapL.preload1 = function( e ) {
	console.log( "map preload1() mapchips" );
	//マップチップロードしている
	this.preloader = new Preloader( this.table3, this.mapchips );
	this.preloader.onCompletex = this.preload2.bind( this );
	this.preloader.exec();
}

mapL.preload2 = function( e ) {
	console.log( "map preload2() maps" );
	//マップロードしている
	this.preloader = new Preloader( this.imageNames, this.images );
	this.preloader.onCompletex = this.preload3.bind( this );
	this.preloader.exec();
}

mapL.preload3 = function( e ) {
	console.log( "map preload3() chars" );
	//マップロードしている
	this.preloader = new Preloader( this.table4, this.charImages );
	this.preloader.onCompletex = this.onPreloadedx.bind( this );
	this.preloader.exec();
}

mapL.onPreloadedx = function( e ) {
/*
	画像ロード完了後、マップ画像からマップデータを作成する。
	準備処理終了をメインに知らせる。
*/
	console.log( "map onPreloadedx()" );
	
	var bc = document.getElementById( "backCanvas" ).getContext( "2d" );
	
	//全体マップ画像→データ
	bc.drawImage( this.images[ 0 ], 0, 0 );
	var w = this.images[ 0 ].width;
	var h = this.images[ 0 ].height;
	var im = bc.getImageData( 0, 0, w, h );
	var ids = new Object();
	this.maps.land = new Array();
	for( var y = 0; y < h; y++ ) {
		this.maps.land[ y ] = new Array();
		for( var x = 0; x < w; x++ ) {
			var p = y * w * 4 + x * 4;
			var r = im.data[ p++ ];
			var g = im.data[ p++ ];
			var b = im.data[ p++ ];
			var a = im.data[ p++ ];
			var id = r + "_" + g + "_" + b;
			ids[ id ] = "";
			var value = r * Math.pow( 256, 3 ) + g * Math.pow( 256, 2 ) + b * 256 + a;
			var num = this.table[ id ];
			this.maps.land[ y ][ x ] = num;
		}
	}
	if( 0 ) {
		//使われている色のリストデバッグ出力
		for( var id in ids ) {
			console.log( id );
		}
	}
	if( 0 ) {
		//マップデータデバッグ出力
		for( var y = 0; y < h; y++ ) {
			console.log( this.maps.land[ y ].join( "" ) );
		}
	}

	console.log( "map ready" );
	this.preloaded = true;	//メインのオブザーバーがこれを見ている。

}


//関数 5 / 5		..	
mapL.keyExec = function() {
	//key map
	if( ! this.scrolling ) {
		for( var i = 0; i < keys.length; i++ ) {
			var key = keys[ i ];
			d = 12;
			switch( key ) {
				case 37:
					playerDirection = 0;
					this.anms.push( new Anm( d, this.scrollTime, this, "screenOffsetX", null, function() {
						//１スクロール完了時
						playerX -= 1;
						this.object.screenOffsetX = 0;
						this.object.scrolling = false;
						this.object.movedFlg = true;
					} ) );
					this.scrolling = true;
					break;
				case 38:
					playerDirection = 1;
					this.anms.push( new Anm( d, this.scrollTime, this, "screenOffsetY", null, function() {
						//１スクロール完了時
						playerY -= 1;
						this.object.screenOffsetY = 0;
						this.object.scrolling = false;
						this.object.movedFlg = true;
					} ) );
					this.scrolling = true;
					break;
				case 39:
					playerDirection = 2;
					this.anms.push( new Anm( -d, this.scrollTime, this, "screenOffsetX", null, function() {
						//１スクロール完了時
						playerX += 1;
						this.object.screenOffsetX = 0;
						this.object.scrolling = false;
						this.object.movedFlg = true;
					} ) );
					this.scrolling = true;
					break;
				case 40:
					playerDirection = 3;
					this.anms.push( new Anm( -d, this.scrollTime, this, "screenOffsetY", null, function() {
						//１スクロール完了時
						playerY += 1;
						this.object.screenOffsetY = 0;
						this.object.scrolling = false;
						this.object.movedFlg = true;
					} ) );
					this.scrolling = true;
					break;
				default:
					console.log( key );
					onkeyup( {which:key} );
			}//switch
		}//for
	}//if
}
mapL.frame = function( cc ) {
/*
	スクロールのアニメ処理や、
	画面描画
*/
	
	this.movedFlg = false;
	
	//animate map
	for( var i = 0; i < this.anms.length; i++ ) {
		var anm = this.anms[ i ];
		
			anm.step();
				//check.
				if( anm.deleteFLG ) {
					anm = null;
					this.anms.splice( i--, 1 );
					continue;
				}

			anm.frame();
	}
	//draw map
	
//	if( 1 || this.scrolling ) console.log( this.scrolling, this.screenOffsetX, this.drawFlg );
//	if( this.drawFlg )
	for( var z = 0; z < 10; z++ )
	switch( z ) {
		case 0:
			//マップチップ描画
			var gx, gy, gw, gh;
			for( var row = 0; row < this.matrixMaxRows; row++ ) {
				gy = this.screenOffsetY + row * 16 - 8;
				for( var col = 0; col < this.matrixMaxCols; col++ ) {
					gx = this.screenOffsetX + col * 16 - 8;
					var land = this.maps.land;
					var mx = playerX - this.playerCol + col;
					var my = playerY - this.playerRow + row;
						//check.
						if( my < 0 ) {
							my += land.length;
						} else if( my >= land.length ) {
							my -= land.length;
						}
						if( mx < 0 ) {
							mx += land[ my ].length;
						} else if( mx >= land[ my ].length ) {
							mx -= land[ my ].length;
						}
					var num = this.maps.land[ my ][ mx ];
					if( 1 ) {
						cc.drawImage( this.mapchips[ num ], gx, gy, 16, 16 );
					} else {
						var color = "rgb(" + this.table2[ num ].replace( /_/g, "," ) + ")";
						cc.fillStyle = color;
						cc.fillRect( gx, gy, 16, 16 );
					}
				}
			}
			break;
		case 1:
			if( 0 ) {
				//grid map matrix
				var gx, gy, gw, gh;
				cc.strokeStyle = "gray";
				for( var row = 0; row < this.matrixMaxRows; row++ ) {
					gy = this.screenOffsetY + row * 16 - 8;
					for( var col = 0; col < this.matrixMaxCols; col++ ) {
						gx = this.screenOffsetX + col * 16 - 8;
						cc.strokeRect( gx, gy, 16, 16 );
					}
				}
			}
			if( 0 ) {
				//grid map
				cc.strokeStyle = "rgb(0,255,0)";
				gx = 1 * 16 - 8;
				gy = 1 * 16 - 8;
				gw = ( this.matrixMaxCols - 2 ) * 16;
				gh = ( this.matrixMaxRows - 2 ) * 16;
				cc.strokeRect( gx, gy, gw, gh );
			}
			break;
		case 2:
			//player
			var gx = this.playerCol * 16 - 8;
			var gy = this.playerRow * 16 - 8;
			var img = this.charImages[ 0 ];
			var w = img.width / 4;
			var h = img.height / 2;
			var sy = Math.floor( this.charTick ) * h;
			var sx = playerDirection * w;
			cc.drawImage( img, sx, sy, w, h, gx, gy, 16, 16 );
			break;
		case 8:
			if( 0 ) {
				//十字グリッド
				cc.strokeStyle = "blue";
				//横線
				cc.beginPath();
				cc.moveTo( 0, cc.canvas.height / 2 );
				cc.lineTo( cc.canvas.width, cc.canvas.height / 2 );
				cc.closePath();
				cc.stroke();
				//縦線
				cc.beginPath();
				cc.moveTo( cc.canvas.width / 2, 0 );
				cc.lineTo( cc.canvas.width / 2, cc.canvas.height );
				cc.closePath();
				cc.stroke();
			}
			break;
		case 9:
			//デバッグ
			cc.locate( 0, 0 );
			cc.println( playerX + ", " + playerY );
			cc.textsDraw();
			break;
	}
	
	//歩行時イベント
	if( this.movedFlg ) {
		this.movedFlg = false;
		EE( this, "over", playerX, playerY );
	}
}
