alert(1);
console.log( "sounds.js loading.." );
/*
	<script src=".."></script>
	bgm.fight.play();
	bgm.pause();
	sounds.select.play();
	
*/
var sounds = new Object();
var bgms = new Object();

sounds_preloaded = false;


//音楽ファイル指定（効果音）
sound_infomations_default = {
	select : {
		src	:	"/_snd/ピ/select02.mp3",
	},
	pi : {
		src	:	"/_snd/ピ/select02.mp3",
	},
};


//音楽ファイル指定（楽曲）
bgm_infomations_default = {
	fight : {
		title	:	"騎兵戦",
		composer:	"甘茶",
		src	:	"/_snd/bgm_fight/kiheisen.mp3",
		license	:	"http://amachamusic.chagasi.com/terms.html",
		site	:	"http://amachamusic.chagasi.com/music_kiheisen.html",
	},
	field : {
		title	:	"フォボス〜変拍子によるマーチ",
		composer:	"甘茶",
		src		:	"/_snd/bgm_field/phobos.mp3",
		license	:	"http://amachamusic.chagasi.com/terms.html",
		site	:	"http://amachamusic.chagasi.com/music_phobos.html",
	},
};



	//check.　事前のsound_infomationsに追加する形にする
	if( ! sound_infomations ) var sound_infomations = new Object();
	if( ! bgm_infomations ) var bgm_infomations = new Object();

	for( var name in sound_infomations_default ) {
		sound_infomations[ name ] = sound_infomations_default[ name ];
	}
	for( var name in bgm_infomations_default ) {
		bgm_infomations[ name ] = bgm_infomations_default[ name ];
	}

//１つの音データ読み込み完了時
function sounds_preload( e ) {
	sounds_count++;
	console.log( "a sound preloaded " + sounds_count + "/" + sounds_length );
	e.target.oncanplaythrough = null;
		//check.
		if( sounds_count == sounds_length ) {
			sounds_preloaded = true;
		}
}

//パス情報を音情報へ切り替え
sounds_length = Object.keys( sound_infomations ).length + Object.keys( bgm_infomations ).length;
sounds_count = 0;
for( var name in sound_infomations ) {
	var audio = new Audio( sound_infomations[ name ].src );
		audio.oncanplaythrough = sounds_preload;
		audio.load();
		sounds[ name ] = audio;
		sounds[ name ].name = name;
}
for( var name in bgm_infomations ) {
	var audio = new Audio( bgm_infomations[ name ].src );
		audio.oncanplaythrough = sounds_preload;
		audio.loop = true;
		audio.load();
		bgms[ name ] = audio;
		bgms[ name ].name = name;
}

//演奏中のBGMを止める
bgms.pause = function() {
	for( var name in bgms ) {
		if( bgms[ name ].pause ) bgms[ name ].pause();
	}
}

for( var name in bgms ) {
	var audio = bgms[ name ];
	audio.play2 = function() {
		//全曲停止
		for( var name in bgms ) if( bgms[ name ].pause ) bgms[ name ].pause();
		this.play();
		bgms_current = this;
		if( e = document.getElementById( "bgminfo" ) ) {
			var info = bgm_infomations[ this.name ];
			e.innerHTML = "<a href='javascript:bgminfo( \"" + this.name + "\" )'>BGM「" + info.title + "」</a>";
		}
	}
}
function bgminfo( name ) {
	var info = bgm_infomations[ name ];
	var alertst = "- Music Infomation -\n";
		alertst += "Title:\t\t" + info.title + "\n";
		alertst += "Composer:\t" + info.composer + "\n";
		alertst += "License:\t" + info.license + "\n";
		alertst += "Site:\t\t" + info.site + "\n";
	alert( alertst );
}

for( var name in sounds ) {
	var audio = sounds[ name ];
	audio.play2 = function() {
		this.currentTime = 0;
		this.play();
	}
}
